/*
 * Copyright (c) 2015, StrategyQuant - All rights reserved.
 *
 * Code in this file was made in a good faith that it is correct and does what it should. 
 * If you found a bug in this code OR you have an improvement suggestion OR you want to include 
 * your own code snippet into our standard library please contact us at:
 * http://tasks.strategyquant.com/projects/snippets/
 *
 * This code can be used only within StrategyQuant products. 
 * Every owner of valid (free, trial or commercial) license of any StrategyQuant product 
 * is allowed to freely use, copy, modify or make derivative work of this code without limitations,
 * to be used in all StrategyQuant products and share his/her modifications or derivative work 
 * with the StrategyQuant community.
 *  
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, 
 * INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR 
 * PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS BE LIABLE FOR ANY CLAIM, DAMAGES 
 * OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, 
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 *  
 */
package com.strategyquant.extend.StatValues;

import com.strategyquant.lib.results.SQOrder;
import com.strategyquant.lib.results.SQOrderList;
import com.strategyquant.lib.results.SQStats;
import com.strategyquant.lib.results.StatValue;
import com.strategyquant.lib.results.StatsConst;
import com.strategyquant.lib.results.StatsTypeCombination;
import com.strategyquant.lib.settings.SQSettings;
import com.strategyquant.lib.utils.SQUtils;

public class NumberOfTradesValues extends StatValue {
	private int countProfits;
	private int countLosses;
	private int countCanceled;
	private int numberOfLiveOrders;
	
	@Override
	public String dependsOn() {
		return StatsConst.join(StatsConst.TOTAL_TRADING_DAYS, StatsConst.TOTAL_TRADING_MONTHS, StatsConst.TOTAL_TRADING_YEARS);
	}
	
	@Override
	public void initCompute(SQStats stats, StatsTypeCombination combination, SQOrderList ordersList, SQSettings settings, SQStats statsLong, SQStats statsShort) throws Exception {
		countProfits = 0;
		countLosses = 0;
		countCanceled = 0;
		numberOfLiveOrders = 0;
	}

	@Override
	public void computeForOrder(SQStats stats, StatsTypeCombination combination, SQOrder order, SQSettings settings, SQStats statsLong, SQStats statsShort) throws Exception {
	    if(order.isFilledOrder() && order.isRealOrder()) {
	    	numberOfLiveOrders++;
	    }
		
		if(order.isCanceledOrder()) {
			countCanceled++;
		} else {
			if(order.PL > 0) {
				countProfits++;
			} else {
				countLosses++;
			}
		}
	}

	@Override
	public void endCompute(SQStats stats, StatsTypeCombination combination, SQOrderList ordersList, SQSettings settings, SQStats statsLong, SQStats statsShort) throws Exception {
		// total number of trades
		int totalTrades = ordersList.size();
		
		stats.set(StatsConst.NUMBER_OF_TRADES, numberOfLiveOrders);
		stats.set(StatsConst.NUMBER_OF_PROFITS, countProfits);
		stats.set(StatsConst.NUMBER_OF_LOSSES, countLosses);
		stats.set(StatsConst.NUMBER_OF_CANCELED, countCanceled);

		double winLossRatio = SQUtils.safeDivide(countProfits, countLosses);
		stats.set(StatsConst.WIN_LOSS_RATIO, SQUtils.round2(winLossRatio));
		
		int totalDaysOfTrading = stats.getInt(StatsConst.TOTAL_TRADING_DAYS);
		int totalMonthsOfTrading = stats.getInt(StatsConst.TOTAL_TRADING_MONTHS);
		int totalYearsOfTrading = stats.getInt(StatsConst.TOTAL_TRADING_YEARS);
		
		// average number of trades
		stats.set(StatsConst.AVG_TRADES_PER_DAY, SQUtils.round2(SQUtils.safeDivide(totalTrades, totalDaysOfTrading)));
		stats.set(StatsConst.AVG_TRADES_PER_MONTH, SQUtils.round2(SQUtils.safeDivide(totalTrades, totalMonthsOfTrading)));
		stats.set(StatsConst.AVG_TRADES_PER_YEAR, SQUtils.round2(SQUtils.safeDivide(totalTrades, totalYearsOfTrading)));

		double winningPct = SQUtils.safeDivide(countProfits, countProfits+countLosses) * 100;
		stats.set(StatsConst.WINNING_PCT, SQUtils.round2(winningPct));
		
	}
}